"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPathBBox = void 0;
var path_length_factory_1 = require("./path-length-factory");
/**
 * Returns the bounding box of a shape.
 */
function getPathBBox(path) {
    if (!path) {
        return {
            x: 0,
            y: 0,
            width: 0,
            height: 0,
            x2: 0,
            y2: 0,
            cx: 0,
            cy: 0,
            cz: 0,
        };
    }
    var _a = (0, path_length_factory_1.pathLengthFactory)(path), _b = _a.min, xMin = _b.x, yMin = _b.y, _c = _a.max, xMax = _c.x, yMax = _c.y;
    var width = xMax - xMin;
    var height = yMax - yMin;
    return {
        width: width,
        height: height,
        x: xMin,
        y: yMin,
        x2: xMax,
        y2: yMax,
        cx: xMin + width / 2,
        cy: yMin + height / 2,
        // an estimted guess
        cz: Math.max(width, height) + Math.min(width, height) / 2,
    };
}
exports.getPathBBox = getPathBBox;
//# sourceMappingURL=get-path-bbox.js.map