"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTotalLength = void 0;
var path_length_factory_1 = require("./path-length-factory");
/**
 * Returns the shape total length, or the equivalent to `shape.getTotalLength()`.
 *
 * The `normalizePath` version is lighter, faster, more efficient and more accurate
 * with paths that are not `curveArray`.
 */
function getTotalLength(pathInput) {
    return (0, path_length_factory_1.pathLengthFactory)(pathInput).length;
}
exports.getTotalLength = getTotalLength;
//# sourceMappingURL=get-total-length.js.map